void PJ_SpriteAsocia(Sprite *base, Sprite *asociado){
	base->asociado = asociado;
	base->tieneAsociado = true;
}

bool PJ_SpriteCargarRAM(Sprite *s){
	int id = -1;
	for(int i=0;(i<NF_SLOTS_SPR256GFX)&&(id == -1);i++){
		if (NF_SPR256GFX[i].available){
			id = i;
		}
	}
	if (id != -1)
		s->cargarRAM(id);
	else
		return false;
	return true;
}
bool PJ_SpriteCargarRAM(Sprite *s1, Sprite *s2){
	int id1 = -1;
	int id2 = -1;
	for(int i=0;(i<NF_SLOTS_SPR256GFX)&&((id1 == -1)||(id2 == -1));i++){
		if (NF_SPR256GFX[i].available){
			if (id1 == -1)
				id1 = i;
			else
				id2 = i;
		}
	}
	if ((id1 != -1)&&(id2 != -1)){
		PJ_SpriteAsocia(s1,s2);
		s1->cargarRAM(id1,id2);
	}else
		return false;
	return true;
}

bool PJ_SpritePalRAM(Sprite *s){
	int pal = s->paletaRegistrada();
	if ((pal == -1) || (paletas[pal].ram == -1)){
		for(int i=0;(i<NF_SLOTS_SPR256PAL)&&(pal == -1);i++){
			if (NF_SPR256PAL[i].available){
				pal = i;
			}
		}
	}else
		pal = paletas[pal].ram;
	if(pal != -1)
		s->cargaPaletaRAM(pal);
	else
		return false;
	return true;
}
void PJ_SpriteDescargarRAM(Sprite *s){
	s->descargarRAM();
}

void PJ_SpriteDescargarPalRAM(Sprite *s){
	s->descargarPaletaRAM();
}

bool PJ_SpriteCargarVRAM(Sprite *s, bool ahorro){
	int id = -1;
	for(int i=0;(i<128)&&(id == -1);i++){
		if (!NF_SPR256VRAM[s->pantalla][i].inuse){
			id = i;
		}
	}
	if (id != -1)
		s->cargarVRAM(id,ahorro);
	else
		return false;
	return true;
}

bool PJ_SpriteCargarVRAM(Sprite *s1, Sprite *s2){
	int id1 = -1;
	int id2 = -1;
	for(int i=0;(i<128)&&((id1 == -1)||(id2 == -1));i++){
		if ((!NF_SPR256VRAM[s2->pantalla][i].inuse) && (id1 != -1)){
			id2 = i;
		}
		if ((!NF_SPR256VRAM[s1->pantalla][i].inuse) && (id1 == -1)){
			id1 = i;
		}
	}
	if ((id1 != -1)&&(id2 != -1))
		s1->cargarVRAM(id1,id2);
	else
		return false;
	return true;
}

bool PJ_SpritePalVRAM(Sprite *s){
	int pal = s->paletaRegistrada();
	if ((pal == -1) || (paletas[pal].vram == -1)){
		for(int i=0;(i<16)&&(pal == -1);i++){
			if (!NF_SPRPALSLOT[s->pantalla][i].inuse){
				pal = i;
			}
		}
	}else
		pal = paletas[pal].vram;
	if(pal != -1)
		s->cargarPaletaVRAM(pal);
	else
		return false;
	return true;
}

void PJ_SpriteDescargaVRAM(Sprite *s){
	s->descargaVRAM();
}

//	//Crea y muestra el Sprite en la posicion de pantalla y direccion indicada asignandole el identificador
//	//que pasamos como parametro, solo para el caso de Sprite que no tengan dependencias
//	//Si pantalla es "true" indica que le estamos pasando las coordenadas respecto a la pantalla, en caso
//	//contrario respecto al Mapa
//	void crear(int i, int X, int Y, bool pantalla, Direccion d);
//	//Crea y muestra el Sprite "compuesto" en la posicion de pantalla y direccion indicada asignandole a
//	//cada uno el identificador que pasamos como parametro
//	//Si pantalla es "true" indica que le estamos pasando las coordenadas respecto a la pantalla, en caso
//	//contrario respecto al Mapa
//	void crear(int i, int j, int X, int Y, bool pantalla, Direccion d);
//	//Borra el Sprite, los datos se mantienen en la VRAM
//	void borrar();
//	//Indica en que capa debe dibujarse el Sprite (si nadie depende de el)
//	void setCapa(Capa c);
//	//Indica en que capa debe dibujarse cada una de las dos partes del Sprite (debe tener dependencia)
//	void setCapa(Capa c1, Capa c2);
//	//Pone visible el Sprite si previamente a sido ocultado.
//	void mostrar();
//	//Pone invisible el Sprite, aunque este sigue existiendo.
//	void ocultar();
//	//Nos indica si grafico esta oculto
//	bool estaOculto();
//	//Voltea el grafico horizontalmente si b = "true" en caso contrario lo devuelve a su forma orifinal
//	//si ha sido previamente volteado
//	void voltearHorizontal(bool b);
//	//Indica si el grafico esta volteado horizontalmente
//	bool getVolteadoHorizontal();
//	//Voltea el grafico verticalmente si b = "true" en caso contrario lo devuelve a su forma orifinal
//	//si ha sido previamente volteado
//	void voltearVertical(bool b);
//	//Indica si el grafico esta volteado verticalmente
//	bool getVolteadoVertical();
//	//Muestra del sprite el Frame (porcion) indicado
//	void frame(int f);
//	//Pone el Sprite en la direccion indicada (tanto si es o no compuesto), si comprobar es "true" comprueba si es compuesto
//	//en caso contrario actua con el como si no lo fuera
//	void mirar(Direccion d, bool comprobar);
//
//	//Funciones de verificacion
//	//Funcion que devuelve:
//		//-1 Si la paleta no esta asignada
//		//indice del array paletas[64] que indica donde tenemos almacenada la informacion de carga de esa paleta
//	int paletaRegistrada();
//	//registra la paleta en el array, si RAM = "true" modifica su valor de ram, en caso contrario el de vram
//	void registraPaleta(int i, bool ram);
//	//Nos devuelve si el Sprite esta en el radio de "dibujo" para ser creado
//	bool estaCerca();
//	//Nos indica si el Sprite se deberia ver en la pantalla segun su posivion en el Mapa
//	bool enPantalla();
//	//Mueve el Sprite a la posicion dada de la pantalla si "pantalla" = "true", del mapa en caso contrario
//	void mover(int x, int y, bool pantalla);
//	//Mueve el Sprite en la direccion indicada a la velocidad del mismo.
//	void mover(Direccion d);
//	//Anima al personaje simulando movimiento en la direccion indicada
//	void animar(Direccion d);