struct Elemento{
	Direccion d;
	Elemento *siguiente;

	Elemento();
};

Elemento::Elemento(){
	d = ninguna;
	siguiente = NULL;
}

struct Fila{
	int tam;
	int paso;
	bool verBloqueo;
	bool bloqueado;
	Elemento *primero;
	Elemento *actual;
	Elemento *ultimo;

	Fila();
	void add(Direccion d);
	void add(Direccion d, int nVeces);
	//Devuelve primer elemento y lo borra
	Direccion getPrimero();
	//Devuelve el elemento actual, no lo borra y pasa al siguiente
	Direccion getActualN(int N);
	//Devuelve el primer elemento y lo borra cuando lo ha devuelto N veces.
	Direccion getPasoN(int N);
	void clear();
};

Fila::Fila(){
	tam = 0;
	paso = 0;
	verBloqueo = true;
	bloqueado = false;
	primero = NULL;
	actual = NULL;
	ultimo = NULL;
}

void Fila::add(Direccion d){
	Elemento *e = new Elemento();
	e->d = d;

	if (tam == 0){
		primero = e;
		actual = e;
		ultimo = e;
	}else{
		ultimo->siguiente = e;
		ultimo = e;
	}
	tam++;
}

void Fila::add(Direccion d, int nVeces){
	for(int i=0;i<nVeces;i++){
		add(d);
	}
}

Direccion Fila::getPrimero(){
	Direccion dir;
	if (primero != NULL){
		dir = primero->d;
		Elemento *e = primero;
		primero = primero->siguiente;
		free(e);
		tam--;
	}else
		dir = ninguna;
	return dir; 
}

Direccion Fila::getActualN(int N){
	Direccion dir = actual->d;

	if (paso == N-1){
		paso = 0;
		if (actual->siguiente != NULL)
			actual = actual->siguiente;
		else
			actual = primero;
	}else{
		paso++;
	}


	return dir;
}

Direccion Fila::getPasoN(int N){
	if (primero != NULL){
		if (paso == N-1){
			paso = 0;
			return getPrimero();
		}else{
			paso++;
			return primero->d;
		}
	}else
		return ninguna;
}

void Fila::clear(){
	Elemento *e;
	while (primero != NULL){
		e = primero;
		primero = primero->siguiente;
		free(e);
		tam--;
	}
}