#include <nds.h>

typedef struct {
		bool up;
		bool down;
		bool left;
		bool right;
		bool a;
		bool b;
		bool x;
		bool y;
		bool l;
		bool r;
		bool start;
		bool select;
} keypad_info;

typedef struct{
	int x;
	int y;
}stylus_info;

//Almacena las teclas "HELD" (se estan manteniendo pulsadas)
keypad_info keyheld;
//Almcana las teclas "DOWN" (las que se acaban de pulsar)
keypad_info keydown;
//Almacena las teclas "UP" (las que se acaban de soltar)
keypad_info keyup;
//Almacena las coordenadas pulsadas en la pantalla tactil
stylus_info lapiz;

void ReadKeyPad(void) {

	u16 keys = 0;	// Variable lectura

	//Lee el teclado via Libnds
	scanKeys();

	// Teclas "HELD"
	keys = keysHeld();
	if (keys & KEY_UP) {keyheld.up = true;} else {keyheld.up = false;}
	if (keys & KEY_DOWN) {keyheld.down = true;} else {keyheld.down = false;}
	if (keys & KEY_LEFT) {keyheld.left = true;} else {keyheld.left = false;}
	if (keys & KEY_RIGHT) {keyheld.right = true;} else {keyheld.right = false;}
	if (keys & KEY_A) {keyheld.a = true;} else {keyheld.a = false;}
	if (keys & KEY_B) {keyheld.b = true;} else {keyheld.b = false;}
	if (keys & KEY_X) {keyheld.x = true;} else {keyheld.x = false;}
	if (keys & KEY_Y) {keyheld.y = true;} else {keyheld.y = false;}
	if (keys & KEY_L) {keyheld.l = true;} else {keyheld.l = false;}
	if (keys & KEY_R) {keyheld.r = true;} else {keyheld.r = false;}
	if (keys & KEY_START) {keyheld.start = true;} else {keyheld.start = false;}
	if (keys & KEY_SELECT) {keyheld.select = true;} else {keyheld.select = false;}

	// Teclas "DOWN"
	keys = keysDown();
	if (keys & KEY_UP) {keydown.up = true;} else {keydown.up = false;}
	if (keys & KEY_DOWN) {keydown.down = true;} else {keydown.down = false;}
	if (keys & KEY_LEFT) {keydown.left = true;} else {keydown.left = false;}
	if (keys & KEY_RIGHT) {keydown.right = true;} else {keydown.right = false;}
	if (keys & KEY_A) {keydown.a = true;} else {keydown.a = false;}
	if (keys & KEY_B) {keydown.b = true;} else {keydown.b = false;}
	if (keys & KEY_X) {keydown.x = true;} else {keydown.x = false;}
	if (keys & KEY_Y) {keydown.y = true;} else {keydown.y = false;}
	if (keys & KEY_L) {keydown.l = true;} else {keydown.l = false;}
	if (keys & KEY_R) {keydown.r = true;} else {keydown.r = false;}
	if (keys & KEY_START) {keydown.start = true;} else {keydown.start = false;}
	if (keys & KEY_SELECT) {keydown.select = true;} else {keydown.select = false;}

	// Teclas "UP"
	keys = keysUp();
	if (keys & KEY_UP) {keyup.up = true;} else {keyup.up = false;}
	if (keys & KEY_DOWN) {keyup.down = true;} else {keyup.down = false;}
	if (keys & KEY_LEFT) {keyup.left = true;} else {keyup.left = false;}
	if (keys & KEY_RIGHT) {keyup.right = true;} else {keyup.right = false;}
	if (keys & KEY_A) {keyup.a = true;} else {keyup.a = false;}
	if (keys & KEY_B) {keyup.b = true;} else {keyup.b = false;}
	if (keys & KEY_X) {keyup.x = true;} else {keyup.x = false;}
	if (keys & KEY_Y) {keyup.y = true;} else {keyup.y = false;}
	if (keys & KEY_L) {keyup.l = true;} else {keyup.l = false;}
	if (keys & KEY_R) {keyup.r = true;} else {keyup.r = false;}
	if (keys & KEY_START) {keyup.start = true;} else {keyup.start = false;}
	if (keys & KEY_SELECT) {keyup.select = true;} else {keyup.select = false;}

}

void ReadStylus(){
	touchPosition d;
	touchRead(&d);
	lapiz.x = d.px;
	lapiz.y = d.py;
}